<?php
/**
 * Transfomier-Klasse
 *
 */
class T {
	
	static function WochentagKurzFromDATE($DATE) {
		$uts = T::DATE2UTS($DATE);
		$nr = date("w",$uts);
		if($nr==0) $ret = "So";
	  	elseif($nr==1) $ret = "Mo";
	  	elseif($nr==2) $ret = "Di";
	  	elseif($nr==3) $ret = "Mi";
	  	elseif($nr==4) $ret = "Do";
	  	elseif($nr==5) $ret = "Fr";
	  	elseif($nr==6) $ret = "Sa";
	  	else $ret = "";
	  	return $ret;
	}
	
	static function DATE2UTS($DATE) {
		if(stripos($DATE,"-")===false) {
			return 0;
		}
		list($j,$m,$t) = explode("-",$DATE);
		$uts = mktime(0,0,0,$m,$t,$j);
		return $uts;
	}
	
	static function DATETIME2UTS($DATETIME) {
		if(stripos($DATETIME,"-")===false) {
			return 0;
		}
		if(stripos($DATETIME,":")===false) {
			return 0;
		}
		$tmp = explode(" ",$DATETIME);
		$DATE = $tmp[0];
		$TIME = $tmp[1];
		list($j,$m,$t) = explode("-",$DATE);
		list($h,$i,$s) = explode(":",$TIME);
		$uts = mktime($h,$i,$s,$m,$t,$j);
		return $uts;
	}
	
	static function DATE2Datum($DATE) {
		if(stripos($DATE,"-")===false) {
			return '';
		}
		if($DATE == "0000-00-00" || $DATE == "0000-00-00 00:00:00") {
			return '';
		}
		if(stripos($DATE," ")!==false) {
			list($date, $time) = explode(" ",$DATE);
			$DATE = $date;
		}
		list($j,$m,$t) = explode("-",$DATE);
		$uts = mktime(0,0,0,$m,$t,$j);
		$Datum = date("d.m.Y",$uts);
		return $Datum;
	}
	
	static function Datum2UTS($Datum) {
		if(stripos($Datum,".")===false) {
			return 0;
		}
		list($t,$m,$j) = explode(".",$Datum);
		$uts = mktime(0,0,0,$m,$t,$j);
		return $uts;
	}
		/**
     * Datum der Form DD.MM.YYYY in UTS vom Taganfang (0 Uhr) umwandeln
     *
     * @param  string  $Datumsstring
     * @return  int  Unixtimestamp
     */
    static function Datum2UTS_Taganfang($Datumsstring) {
        list($Tag,$Monat,$Jahr) = explode(".",$Datumsstring);
        $ret = @mktime(0,0,0,$Monat,$Tag,$Jahr);
        if($ret<=1) $ret = "0";
        return $ret;
    }
    
     /**
     * Datum der Form DD.MM.YYYY in UTS vom Tagende (nchster Tag 0 Uhr) umwandeln
     *
     * @param  string  $Datumsstring
     * @return  int  Unixtimestamp
     */
    static function Datum2UTS_Tagende($Datumsstring) {
        list($Tag,$Monat,$Jahr) = explode(".",$Datumsstring);
        $ret = @mktime(0,0,0,$Monat,($Tag+1),$Jahr);
        if($ret<=1) $ret = "0";
        return $ret;
    }
	
	/**
     * Datum der Form DD.MM.YYYY in UTS vom Schichtanfang (6 Uhr) umwandeln
     *
     * @param  string  $Datumsstring
     * @return  int  Unixtimestamp
     */
    static function Datum2UTS_Schichtanfang($Datumsstring) {
        list($Tag,$Monat,$Jahr) = explode(".",$Datumsstring);
        $ret = @mktime(6,0,0,$Monat,$Tag,$Jahr);
        if($ret<=1) $ret = "0";
        return $ret;
    }

    /**
     * Datum der Form DD.MM.YYYY in UTS vom Schichtende (nchster Tag 6 Uhr) umwandeln
     *
     * @param  string  $Datumsstring
     * @return  int  Unixtimestamp
     */
    static function Datum2UTS_Schichtende($Datumsstring) {
        list($Tag,$Monat,$Jahr) = explode(".",$Datumsstring);
        $ret = @mktime(6,0,0,$Monat,($Tag+1),$Jahr);
        if($ret<=1) $ret = "0";
        return $ret;
    }
	
	static function Datum2DATE($Datum) {
		if(stripos($Datum,".")===false) {
			return 0;
		}
		list($t,$m,$j) = explode(".",$Datum);
		$uts = mktime(0,0,0,$m,$t,$j);
		$ret = date("Y-m-d",$uts);
		return $ret;
	}
	
	/**
	 * UTS in DATE umwandeln
	 *
	 * @param int $UTS
	 * @return string
	 */
	static function UTS2DATE($UTS) {
		if($UTS <= 0) return "";
		$date = date("Y-m-d",$UTS);
		return $date;
	}
	
	/**
	 * UTS in DATE umwandeln
	 *
	 * @param int $UTS
	 * @return string
	 */
	static function UTS2DATETIME($UTS) {
		if($UTS <= 0) return "";
		$date = date("Y-m-d H:i:s",$UTS);
		return $date;
	}
	
	/**
	 * UTS in Datum umwandeln
	 *
	 * @param int $UTS
	 * @return string
	 */
	static function UTS2Datum($UTS) {
		if($UTS <= 0) return "";
		$date = date("d.m.Y",$UTS);
		return $date;
	}
	
	static function UTS2DatumZeit($UTS) {
		if($UTS <= 0) return "";
		$date = date("d.m.Y H:i:s",$UTS);
		return $date;
	}
	
	/**
	 * DECimalzahl in FLOAT umwandeln
	 *
	 * @param string $DEC
	 * @return float
	 */
	static function DEC2FLOAT($DEC) {
		$ret = str_replace(".","",$DEC);
    	$ret = str_replace(",",".",$ret);
    	return $ret;
	}
	
	/**
     * FLOAT in DECimalzahl umwandeln
     *
     * @param float $Zahl
     * @param int $Kommastellen (-1 fr Automatisch)
     * @param bool $LeerstringStatt0
     * @return string
     */
    static function FLOAT2DEC($Zahl, $Kommastellen = 0, $LeerstringStatt0 = false) {
    	if($Zahl==0 && $LeerstringStatt0) {
    		return "";
    	}
    	$strZahl = (string) $Zahl;
    	if($Kommastellen == -1) {
    		$PunktPos = strrpos($strZahl,".");
    		if($PunktPos===false) {
    			$Kommastellen = 0;
    		} else {
    			$Kommastellen = (strlen($strZahl) - $PunktPos) - 1;
    		}
    	} else {
    		$Zahl = round($Zahl,$Kommastellen);
    	}
    	$erg = number_format($Zahl +0,$Kommastellen,",",".");
    	return $erg;
    }
	
	static function JN2JaNein($JN_Bool) {
		if($JN_Bool == "J") return "Ja";
		else                return "Nein";
	}
	
	/**
     * Boolwert in J/N umwandeln
     *
     * @param  string
     * @return  float
     */
    static function Bool2JN($Bool) {
    	if($Bool == true || $Bool == "true" || $Bool == "J" || $Bool == "1") $ret = "J";
    	if($Bool == false || $Bool == "false" || $Bool == "N" || $Bool == "0" || $Bool == "") $ret = "N";
    	return $ret;
    }
}
?>